Imports GrapeCity.ActiveReports


Public Class frmEinheitspapierVersandverfahren
    Dim EPBES As cEP0735_Versand
   
    Dim WT_LIST As VERAG_PROG_ALLGEMEIN.cZollTarifAtlas_LIST

    Private Sub pic_Click(sender As Object, e As EventArgs)
    End Sub

    Private Sub Panel3_Paint(sender As Object, e As PaintEventArgs)

    End Sub

    Private Sub frmEinheitspapier_Load(sender As Object, e As EventArgs) Handles Me.Load
        EPBES = New cEP0735_Versand()

        WT_LIST = New VERAG_PROG_ALLGEMEIN.cZollTarifAtlas_LIST
        UsrCntlEinheitspapier1.WT_LIST = WT_LIST
        cProgramFunctions.initDrucker(cboPrinter, "TALLY")
        MyComboBox1.Items.Add(New VERAG_PROG_ALLGEMEIN.MyListItem("0", "0"))
        MyComboBox1.Items.Add(New VERAG_PROG_ALLGEMEIN.MyListItem("12", "12"))
        MyComboBox1.Items.Add(New VERAG_PROG_ALLGEMEIN.MyListItem("14", "14"))
        MyComboBox1.Items.Add(New VERAG_PROG_ALLGEMEIN.MyListItem("17", "17"))
        MyComboBox1.changeItem("12")

        MyComboBox2.Items.Add(New VERAG_PROG_ALLGEMEIN.MyListItem("0", "0"))
        MyComboBox2.Items.Add(New VERAG_PROG_ALLGEMEIN.MyListItem("12", "12"))
        MyComboBox2.Items.Add(New VERAG_PROG_ALLGEMEIN.MyListItem("14", "14"))
        MyComboBox2.Items.Add(New VERAG_PROG_ALLGEMEIN.MyListItem("17", "17"))
        MyComboBox2.changeItem("17")

    End Sub

  
    Private Sub frmEinheitspapier_Shown(sender As Object, e As EventArgs) Handles Me.Shown
        Me.Height = My.Computer.Screen.WorkingArea.Height
        Me.Top = 0

        'Nachdem WT_LIST gesetzt wurde:
        UsrCntlEinheitspapier1.init()
        UsrCntlEinheitspapier1.FlowLayoutPanel.Controls.Clear()
        UsrCntlEinheitspapier1.addPos()
    End Sub

    Private Sub btnLaden_Click(sender As Object, e As EventArgs)
        
    End Sub

    Sub fillData()
        UsrCntlEinheitspapier1.cboAnmeldung1.Text = If(EPBES.ANMELDUNG1, "")
        UsrCntlEinheitspapier1.cboAnmeldung3.Text = If(EPBES.ANMELDUNG2, "")

        UsrCntlEinheitspapier1.txtVordrucke1.Text = If(EPBES.Vordrucke1, "")
        UsrCntlEinheitspapier1.txtVordrucke2.Text = If(EPBES.Vordrucke2, "")

        UsrCntlEinheitspapier1.cboFiliale.changeItem(If(EPBES.FilialenNr, ""))
        UsrCntlEinheitspapier1.txtAbfertigungsnummer.Text = If(EPBES.AbfertigungsNr, "")
        UsrCntlEinheitspapier1.txtUnternummer.Text = If(EPBES.UnterNr, "")

        UsrCntlEinheitspapier1.txtAnmelder.Text = If(EPBES.Anmelder, "")
        UsrCntlEinheitspapier1.txtAnmelderVertreterNr.Text = If(EPBES.AnmelderVertreterNr, "")

        If UsrCntlEinheitspapier1.FlowLayoutPanel.Controls.Count > 0 Then
            Dim c As usrcntlEinheitspapierPos0735 = UsrCntlEinheitspapier1.FlowLayoutPanel.Controls(0)
            c.txtWarenbezeichnung.Text = If(EPBES.Warenbezeichnung, "")
            c.txtPackstuecke.Text = If(EPBES.Packstücke, "")
            c.txtWtNr1.Text = If(EPBES.Warennummer1, "")
           
            c.txtBesondereVermerke.Text = If(EPBES.BesondereVermerke, "")
            c.txtSumAnmeldungVorpapier.Text = If(EPBES.SumAnmeldungVorpapier, "")

            c.txtRohmasse.Text = If(EPBES.SumAnmeldungVorpapier, "")
            c.txtSumAnmeldungVorpapier.Text = If(EPBES.SumAnmeldungVorpapier, "")

        End If
        'EPBES.Warenbezeichnung
    End Sub


    Sub getData()
        'EPBES = New cEPBes
        EPBES.ANMELDUNG1 = UsrCntlEinheitspapier1.cboAnmeldung1._value
        EPBES.ANMELDUNG3 = UsrCntlEinheitspapier1.cboAnmeldung3._value
        EPBES.TicketNr = UsrCntlEinheitspapier1.txtTicketNr.Text

        EPBES.Vordrucke1 = UsrCntlEinheitspapier1.txtVordrucke1.Text
        EPBES.Vordrucke2 = UsrCntlEinheitspapier1.txtVordrucke2.Text
        EPBES.PackstückeInsgesamt = UsrCntlEinheitspapier1.txtPackstückeInsgesamt.Text
        EPBES.FilialenNr = UsrCntlEinheitspapier1.cboFiliale._value
        EPBES.AbfertigungsNr = UsrCntlEinheitspapier1.txtAbfertigungsnummer.Text
        EPBES.UnterNr = UsrCntlEinheitspapier1.txtUnternummer.Text

        EPBES.Ladelisten = UsrCntlEinheitspapier1.txtladelisten.Text
        EPBES.Positionen = UsrCntlEinheitspapier1.txtPosCount.Text
      
        EPBES.VersenderAusführer = UsrCntlEinheitspapier1.txtVersenderAusführer.Text
        EPBES.VersenderAusführerNr = UsrCntlEinheitspapier1.txtVersenderAusführerEORI.Text

        EPBES.Empfänger = UsrCntlEinheitspapier1.txtEmpfänger.Text
        EPBES.EmpfängerNr = UsrCntlEinheitspapier1.txtEmpfängerEORI.Text()

        EPBES.KennzeichenAbgang = UsrCntlEinheitspapier1.txtKennzeichenAbgang.Text
        EPBES.Container = UsrCntlEinheitspapier1.cboKennzeichenAbgangCtr._value
        EPBES.StaatszugehörigkeitAbgang = UsrCntlEinheitspapier1.cboKennzeichenAbgangLand._value

        EPBES.KennzeichenGrenze = UsrCntlEinheitspapier1.txtKennzeichenGrenzüberschreitung.Text
        EPBES.StaatszugehörigkeitGrenze = UsrCntlEinheitspapier1.cboKennzeichenGrenzüberschreitungLand._value

        EPBES.Ladeort = UsrCntlEinheitspapier1.txtLadeort.Text
        EPBES.VerkehrszweigGrenze = UsrCntlEinheitspapier1.cboVerkehrszweigGrenze._value

        EPBES.Anmelder = UsrCntlEinheitspapier1.txtAnmelder.Text
        EPBES.AnmelderVertreterNr = UsrCntlEinheitspapier1.txtAnmelderVertreterNr.Text

        EPBES.VersendungsAusfuhrland = If(UsrCntlEinheitspapier1.cboVersendungsland._value <> "", UsrCntlEinheitspapier1.cboVersendungsland._value, UsrCntlEinheitspapier1.cboVersendungsland.Text)
        EPBES.VersendungsAusfuhrlandCode = UsrCntlEinheitspapier1.cboVersendungslandCode._value
        EPBES.Bestimmungsland = If(UsrCntlEinheitspapier1.cboBestimmungsland._value <> "", UsrCntlEinheitspapier1.cboBestimmungsland._value, UsrCntlEinheitspapier1.cboBestimmungsland.Text)
        EPBES.BestimmungslandCodeA = UsrCntlEinheitspapier1.cboBestimmungslandCode._value

        EPBES.Hauptverpflichteter = UsrCntlEinheitspapier1.txtHauptverpflichteter.Text
        EPBES.HauptverpflichteterNr = UsrCntlEinheitspapier1.txtHauptverpflichteterEORI.Text
        EPBES.HauptverpflichteterOrtDatum = UsrCntlEinheitspapier1.txtHauptverpflichteterVertretenOrtDatum.Text
        EPBES.HauptverpflichteterVertretenDurch = UsrCntlEinheitspapier1.txtHauptverpflichteterVertretenDurch.Text


        EPBES.Durchgangszollstelle1 = UsrCntlEinheitspapier1.cboDurchgangszollstellen1.Text
        EPBES.Durchgangszollstelle2 = UsrCntlEinheitspapier1.cboDurchgangszollstellen2.Text
        EPBES.Durchgangszollstelle3 = UsrCntlEinheitspapier1.cboDurchgangszollstellen3.Text
        EPBES.Durchgangszollstelle4 = UsrCntlEinheitspapier1.cboDurchgangszollstellen4.Text
        EPBES.Durchgangszollstelle5 = UsrCntlEinheitspapier1.cboDurchgangszollstellen5.Text
        EPBES.Durchgangszollstelle6 = UsrCntlEinheitspapier1.cboDurchgangszollstellen6.Text

        EPBES.Bestimmungsstelle = UsrCntlEinheitspapier1.cboBestimmungszollstelleLand.Text

        EPBES.SicherheitCode = UsrCntlEinheitspapier1.cboSicherheitCode._value
        EPBES.Sicherheit1 = UsrCntlEinheitspapier1.cboSicherheit.Text
        EPBES.Sicherheit2 = UsrCntlEinheitspapier1.txtSicherheit2.Text


        EPBES.Ort = UsrCntlEinheitspapier1.txtOrt.Text
        EPBES.Datum = UsrCntlEinheitspapier1.txtDatum.Text

        EPBES.Unterschrift = UsrCntlEinheitspapier1.txtUnterschriftAnmelder.Text

        EPBES.AngabenFürVerbuchungszwecke = ""


        EPBES.POS.Clear()
        For Each c In UsrCntlEinheitspapier1.FlowLayoutPanel.Controls
            Dim usr As usrcntlEinheitspapierPos0735 = DirectCast(c, usrcntlEinheitspapierPos0735)
            Dim p As New cEP0735_Versand_Pos
            p.PositionsNr = usr.txtPosNr2.Text
            p.Packstücke = usr.txtPackstuecke.Text
            p.Warenbezeichnung = usr.txtWarenbezeichnung.Text
            p.Warennummer1 = usr.txtWtNr1.Text
            p.Rohmasse = usr.txtRohmasse.Text
            p.Eigenmasse = usr.txtEigenmasse.Text
            p.SumAnmeldungVorpapier = usr.txtSumAnmeldungVorpapier.Text
            p.BesondereVermerke = usr.txtBesondereVermerke.Text

            EPBES.POS.Add(p)
        Next

        If EPBES.POS.Count > 0 Then 'Wäre für die 1. Pos zum Speichern
            EPBES.Warenbezeichnung = EPBES.POS(0).Warenbezeichnung
            EPBES.Packstücke = EPBES.POS(0).Packstücke
            EPBES.Präferenz = EPBES.POS(0).Präferenz
            EPBES.Kontingent = EPBES.POS(0).Kontingent
            EPBES.Warennummer1 = EPBES.POS(0).Warennummer1
            EPBES.Warennummer2 = EPBES.POS(0).Warennummer2
            EPBES.Warennummer3 = EPBES.POS(0).Warennummer3
            EPBES.Warennummer4 = EPBES.POS(0).Warennummer4
            EPBES.Warennummer5 = EPBES.POS(0).Warennummer5
            EPBES.BesondereVermerke = EPBES.POS(0).BesondereVermerke
            EPBES.UrsprungslandCode = EPBES.POS(0).UrsprungslandCode
            EPBES.Verfahren = EPBES.POS(0).Verfahren
            EPBES.Eigenmasse = EPBES.POS(0).Eigenmasse
            EPBES.Rohmasse = EPBES.POS(0).Rohmasse
            EPBES.SumAnmeldungVorpapier = EPBES.POS(0).SumAnmeldungVorpapier
            EPBES.BesondereMasseinheit = EPBES.POS(0).BesondereMasseinheit

        End If
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        getData()
        If EPBES Is Nothing Then Exit Sub

        Dim anzahl_736 As Integer = 0
        If EPBES.POS.Count > 1 Then
            ''  MsgBox(((EPBES.POS.Count - 1) / 3) - 0.5)
            ' MsgBox(cProgramFunctions.fctRound(((CDbl(EPBES.POS.Count - 1) / 3) - 0.5), 0))


            anzahl_736 = cProgramFunctions.fctRound(((CDbl(EPBES.POS.Count - 1) / 3) - 0.5), 0) ' -0,5 --> immer abrunden ' -1 weil die erste POS im Hauptformular
            If (EPBES.POS.Count - 1) Mod 3 > 0 Then anzahl_736 += 1
            If MsgBox("Bitte ein Einheitspapier '0735' und " & anzahl_736 & " Ergänzungsfurmulare '0736' in den Tally-Drucker einlegen.", MsgBoxStyle.OkCancel) = MsgBoxResult.Cancel Then
                Exit Sub
            End If
        Else
            If MsgBox("Bitte ein Einheitspapier '0735' in den Tally-Drucker einlegen.", MsgBoxStyle.OkCancel) = MsgBoxResult.Cancel Then
                Exit Sub
            End If
        End If

        Dim cntVordrucke As Integer = 1


        Dim rpt As New rptEinheitspapier0735(MyComboBox1._value)
        ' rpt.lblRgNr.Text = BELEG.rksv_BelegId '"12345 / TR"

        rpt.txtVordrucke1.Text = 1
        rpt.txtVordrucke2.Text = anzahl_736 + 1
        rpt.txtTicketNr.Text = EPBES.TicketNr
        rpt.txtAnmeldung1.Text = If(EPBES.ANMELDUNG1, "")
        rpt.txtAnmeldung2.Text = If(EPBES.ANMELDUNG2, "")
        rpt.txtAnmeldung3.Text = If(EPBES.ANMELDUNG3, "")

        '  rpt.txtVordrucke1.Text = If(EPBES.Vordrucke1, "")
        '  rpt.txtVordrucke2.Text = If(EPBES.Vordrucke2, "")
        rpt.txtLadelisten.Text = If(EPBES.Ladelisten, "")
        rpt.txtPacklistenInsges.Text = If(EPBES.PackstückeInsgesamt, "")
        rpt.txtPositionen.Text = If(EPBES.Positionen, "")

        rpt.txtFiliale.Text = If(EPBES.FilialenNr, "")
        rpt.txtAbfertigungsnummer.Text = If(EPBES.AbfertigungsNr, "")
        rpt.txtUnternummer.Text = If(EPBES.UnterNr, "")
        rpt.txtAnmelder.Text = If(EPBES.Anmelder, "")
        rpt.txtVersender.Text = If(EPBES.VersenderAusführer, "")
        rpt.txtVersenderNr.Text = If(EPBES.VersenderAusführerNr, "")
        rpt.txtEmpfänger.Text = If(EPBES.Empfänger, "")
        rpt.txtEmpfängerNr.Text = If(EPBES.EmpfängerNr, "")
        rpt.txtAnmelder.Text = If(EPBES.Anmelder, "")
        rpt.txtAnmelderVertreterNr.Text = If(EPBES.AnmelderVertreterNr, "")


        rpt.txtVersendungslandAusfuhr.Text = If(EPBES.VersendungsAusfuhrland, "")
        rpt.txtVersendungslandAusfuhrCode.Text = If(EPBES.VersendungsAusfuhrlandCode, "")
        rpt.txtBestimmungsland.Text = If(EPBES.Bestimmungsland, "")
        rpt.txtBestimmungslandCode.Text = If(EPBES.BestimmungslandCodeA, "")


        rpt.txtKennuzeichenAbgang.Text = If(EPBES.KennzeichenAbgang, "")
        rpt.txtKennuzeichenAbgangLand.Text = If(EPBES.StaatszugehörigkeitAbgang, "")
        rpt.txtKennuzeichenAbgangCtr.Text = If(EPBES.Container, "")
        rpt.txtKennzeichenGrenze.Text = If(EPBES.KennzeichenGrenze, "")
        rpt.txtKennzeichenGrenzeLand.Text = If(EPBES.StaatszugehörigkeitGrenze, "")

        rpt.txtVerkehrszweigGrenze.Text = If(EPBES.VerkehrszweigGrenze, "")
        rpt.txtLadeort.Text = If(EPBES.Ladeort, "")

        rpt.txtHauptverpflichteter.Text = If(EPBES.Hauptverpflichteter, "")
        rpt.txtHauptverpflichteterNr.Text = If(EPBES.HauptverpflichteterNr, "")
        rpt.txtVertretenDurch.Text = If(EPBES.HauptverpflichteterVertretenDurch, "")
        rpt.txtVertretenDurchOrtDatum.Text = If(EPBES.HauptverpflichteterOrtDatum, "")

        rpt.txtDurchgangszollstelle1.Text = If(EPBES.Durchgangszollstelle1, "")
        rpt.txtDurchgangszollstelle2.Text = If(EPBES.Durchgangszollstelle2, "")
        rpt.txtDurchgangszollstelle3.Text = If(EPBES.Durchgangszollstelle3, "")
        rpt.txtDurchgangszollstelle4.Text = If(EPBES.Durchgangszollstelle4, "")
        rpt.txtDurchgangszollstelle5.Text = If(EPBES.Durchgangszollstelle5, "")
        rpt.txtDurchgangszollstelle6.Text = If(EPBES.Durchgangszollstelle6, "")
        rpt.txtSicherheit1.Text = If(EPBES.Sicherheit1, "")
        rpt.txtSicherheit2.Text = If(EPBES.Sicherheit2, "")
        rpt.txtSicherheitCode.Text = If(EPBES.SicherheitCode, "")
        rpt.txtBestimmungszollstelle.Text = If(EPBES.Bestimmungsstelle, "")



        rpt.txtAngabenVerbuchungszwecke.Text = If(EPBES.AngabenFürVerbuchungszwecke, "")
        rpt.txtOrt.Text = If(EPBES.Ort, "")
        rpt.txtDatum.Text = If(EPBES.Datum, "")
        rpt.txtUnterschrift.Text = If(EPBES.Unterschrift, "")

        '    rpt.txtAnmeldung1.Text = If(EPBES.ANMELDUNG1, "")

        If EPBES.POS.Count > 0 Then
            rpt.txtPosNr.Text = If(EPBES.POS(0).PositionsNr, "")
            rpt.txtPackstücke.Text = If(EPBES.POS(0).Packstücke, "")
            rpt.txtWarenbezeichnung.Text = If(EPBES.POS(0).Warenbezeichnung, "")
            rpt.txtWtNr1.Text = If(EPBES.POS(0).Warennummer1, "")
            rpt.txtWtNr2.Text = If(EPBES.POS(0).Warennummer2, "")
            rpt.txtWtNr3.Text = If(EPBES.POS(0).Warennummer3, "")
            rpt.txtWtNr4.Text = If(EPBES.POS(0).Warennummer4, "")
            rpt.txtWtNr5.Text = If(EPBES.POS(0).Warennummer5, "")
            rpt.txtUrsprungsland.Text = If(EPBES.POS(0).UrsprungslandCode, "")

            If EPBES.POS(0).Verfahren IsNot Nothing Then
                While EPBES.POS(0).Verfahren.length < 7
                    EPBES.POS(0).Verfahren = EPBES.POS(0).Verfahren & "0"
                End While
                rpt.txtVerfahren1.Text = EPBES.POS(0).Verfahren.ToString.Substring(0, 4)
                rpt.txtVerfahren2.Text = EPBES.POS(0).Verfahren.ToString.Substring(4, 3)
            Else
                rpt.txtVerfahren1.Text = ""
                rpt.txtVerfahren2.Text = ""
            End If
            rpt.txtRohmasse.Text = If(EPBES.POS(0).Rohmasse, "")
            rpt.txtEigenmasse.Text = If(EPBES.POS(0).Eigenmasse, "")
            rpt.txtSummarischeAnmeldung.Text = If(EPBES.POS(0).SumAnmeldungVorpapier, "")
            rpt.txtPraeferenz.Text = If(EPBES.POS(0).Präferenz, "")
            rpt.txtKontingent.Text = If(EPBES.POS(0).Kontingent, "")
            rpt.txtBesondereMasseinheit.Text = If(EPBES.POS(0).BesondereMasseinheit, "")
            rpt.txtBesondereVermerke.Text = If(EPBES.POS(0).BesondereVermerke, "")

        End If


        Try
            rpt.Run(False)
            rpt.Document.Printer.PrinterName = cboPrinter._value
            rpt.Document.Print(CBool(cboPrinter.Text = ""), False)
            rpt.Dispose()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

       

        Dim cnt = 1
        If EPBES.POS.Count > 1 Then 'größer als 1 --> in Dreier-Schritten
            For i = 1 To anzahl_736
                Dim POS1 As cEP0735_Versand_Pos = Nothing
                Dim POS2 As cEP0735_Versand_Pos = Nothing
                Dim POS3 As cEP0735_Versand_Pos = Nothing
                If EPBES.POS.Count > cnt Then
                    POS1 = EPBES.POS(cnt) : cnt += 1
                End If
                If EPBES.POS.Count > cnt Then
                    POS2 = EPBES.POS(cnt) : cnt += 1
                End If
                If EPBES.POS.Count > cnt Then
                    POS3 = EPBES.POS(cnt) : cnt += 1
                End If
                cntVordrucke += 1 'erstes Blatt= 0735
                gen736(EPBES, POS1, POS2, POS3, cntVordrucke, anzahl_736 + 1)
            Next
        End If

    End Sub


    Private Sub gen736(EPBES As cEP0735_Versand, POS1 As cEP0735_Versand_Pos, POS2 As cEP0735_Versand_Pos, POS3 As cEP0735_Versand_Pos, Vordrucke1 As Integer, Vordrucke2 As Integer)
        If POS1 Is Nothing Then Exit Sub

        ' Dim print As New frmPrintLayout
        Dim rpt As New rptEinheitspapier0736(MyComboBox2._value)

        rpt.txtVersender.Text = EPBES.VersenderAusführer
        rpt.txtVersenderNr.Text = EPBES.VersenderAusführerNr
        rpt.txtAnmeldung1.Text = EPBES.ANMELDUNG1
        rpt.txtAnmeldung2.Text = EPBES.ANMELDUNG2
        rpt.txtAnmeldung3.Text = EPBES.ANMELDUNG3
        rpt.txtVordrucke1.Text = Vordrucke1
        rpt.txtVordrucke2.Text = Vordrucke2

        rpt.txtTicketNr.Text = EPBES.TicketNr
        ' rpt.lblRgNr.Text = BELEG.rksv_BelegId '"12345 / TR"

        '    rpt.txtAnmeldung1.Text = If(EPBES.ANMELDUNG1, "")

        rpt.txtWtNr1_1.Text = ""
        rpt.txtPackstücke1.Text = ""
        rpt.txtWarenbezeichnung1.Text = ""
        rpt.txtBesondereVermerke1.Text = ""
        rpt.txtWtNr2_1.Text = ""
        rpt.txtWtNr3_1.Text = ""
        rpt.txtWtNr4_1.Text = ""
        rpt.txtWtNr5_1.Text = ""
        rpt.txtUrsprungsland1.Text = ""
        rpt.txtVerfahren1_1.Text = ""
        rpt.txtVerfahren2_1.Text = ""
        rpt.txtEigenmasse1.Text = ""
        rpt.txtRohmasse1.Text = ""
        rpt.txtSummarischeAnmeldung1.Text = ""
        rpt.txtBesondereMasseinheit1.Text = ""
        rpt.txtKontingent1.Text = ""
        rpt.txtPraeferenz1.Text = ""
        rpt.txtPosNr1.Text = ""
        rpt.txtWtNr1_2.Text = ""
        rpt.txtPackstücke2.Text = ""
        rpt.txtWarenbezeichnung2.Text = ""
        rpt.txtBesondereVermerke2.Text = ""
        rpt.txtWtNr2_2.Text = ""
        rpt.txtWtNr3_2.Text = ""
        rpt.txtWtNr4_2.Text = ""
        rpt.txtWtNr5_2.Text = ""
        rpt.txtUrsprungsland2.Text = ""
        rpt.txtVerfahren1_2.Text = ""
        rpt.txtVerfahren2_2.Text = ""
        rpt.txtEigenmasse2.Text = ""
        rpt.txtRohmasse2.Text = ""
        rpt.txtSummarischeAnmeldung2.Text = ""
        rpt.txtBesondereMasseinheit2.Text = ""
        rpt.txtKontingent2.Text = ""
        rpt.txtPraeferenz2.Text = ""
        rpt.txtPosNr2.Text = ""
        rpt.txtWtNr1.Text = ""
        rpt.txtPackstücke.Text = ""
        rpt.txtWarenbezeichnung.Text = ""
        rpt.txtBesondereVermerke.Text = ""
        rpt.txtWtNr2.Text = ""
        rpt.txtWtNr3.Text = ""
        rpt.txtWtNr4.Text = ""
        rpt.txtWtNr5.Text = ""
        rpt.txtUrsprungsland.Text = ""
        rpt.txtVerfahren1.Text = ""
        rpt.txtVerfahren2.Text = ""
        rpt.txtEigenmasse.Text = ""
        rpt.txtRohmasse.Text = ""
        rpt.txtSummarischeAnmeldung.Text = ""
        rpt.txtBesondereMasseinheit.Text = ""
        rpt.txtKontingent.Text = ""
        rpt.txtPraeferenz.Text = ""
        rpt.txtPosNr.Text = ""

        If POS1 IsNot Nothing Then
            rpt.txtPosNr.Text = If(POS1.PositionsNr, "")
            rpt.txtPackstücke.Text = If(POS1.Packstücke, "")
            rpt.txtWarenbezeichnung.Text = If(POS1.Warenbezeichnung, "")
            rpt.txtWtNr1.Text = If(POS1.Warennummer1, "")
            rpt.txtWtNr2.Text = If(POS1.Warennummer2, "")
            rpt.txtWtNr3.Text = If(POS1.Warennummer3, "")
            rpt.txtWtNr4.Text = If(POS1.Warennummer4, "")
            rpt.txtWtNr5.Text = If(POS1.Warennummer5, "")
            rpt.txtUrsprungsland.Text = If(POS1.UrsprungslandCode, "")

            If POS1.Verfahren IsNot Nothing Then
                While POS1.Verfahren.length < 7
                    POS1.Verfahren = POS1.Verfahren & "0"
                End While
                rpt.txtVerfahren1.Text = POS1.Verfahren.ToString.Substring(0, 4)
                rpt.txtVerfahren2.Text = POS1.Verfahren.ToString.Substring(4, 3)
            Else
                rpt.txtVerfahren1.Text = ""
                rpt.txtVerfahren2.Text = ""
            End If
            rpt.txtEigenmasse.Text = If(POS1.Eigenmasse, "")
            rpt.txtRohmasse.Text = If(POS1.Rohmasse, "")

            rpt.txtSummarischeAnmeldung.Text = If(POS1.SumAnmeldungVorpapier, "")
            rpt.txtPraeferenz.Text = If(POS1.Präferenz, "")
            rpt.txtKontingent.Text = If(POS1.Kontingent, "")
            rpt.txtBesondereMasseinheit.Text = If(POS1.BesondereMasseinheit, "")
            rpt.txtBesondereVermerke.Text = If(POS1.BesondereVermerke, "")

        End If

        If POS2 IsNot Nothing Then
            rpt.txtPosNr1.Text = If(POS2.PositionsNr, "")
            rpt.txtPackstücke1.Text = If(POS2.Packstücke, "")
            rpt.txtWarenbezeichnung1.Text = If(POS2.Warenbezeichnung, "")
            rpt.txtWtNr1_1.Text = If(POS2.Warennummer1, "")
            rpt.txtWtNr2_1.Text = If(POS2.Warennummer2, "")
            rpt.txtWtNr3_1.Text = If(POS2.Warennummer3, "")
            rpt.txtWtNr4_1.Text = If(POS2.Warennummer4, "")
            rpt.txtWtNr5_1.Text = If(POS2.Warennummer5, "")
            rpt.txtUrsprungsland1.Text = If(POS2.UrsprungslandCode, "")

            If POS2.Verfahren IsNot Nothing Then
                While POS2.Verfahren.length < 7
                    POS2.Verfahren = POS2.Verfahren & "0"
                End While
                rpt.txtVerfahren1_1.Text = POS2.Verfahren.ToString.Substring(0, 4)
                rpt.txtVerfahren2_1.Text = POS2.Verfahren.ToString.Substring(4, 3)
            Else
                rpt.txtVerfahren1_1.Text = ""
                rpt.txtVerfahren2_1.Text = ""
            End If
            rpt.txtEigenmasse1.Text = If(POS2.Eigenmasse, "")
            rpt.txtRohmasse1.Text = If(POS2.Rohmasse, "")
            rpt.txtSummarischeAnmeldung1.Text = If(POS2.SumAnmeldungVorpapier, "")
            rpt.txtPraeferenz1.Text = If(POS2.Präferenz, "")
            rpt.txtKontingent1.Text = If(POS2.Kontingent, "")
            rpt.txtBesondereMasseinheit1.Text = If(POS2.BesondereMasseinheit, "")
            rpt.txtBesondereVermerke1.Text = If(POS2.BesondereVermerke, "")

        End If

        If POS3 IsNot Nothing Then
            rpt.txtPosNr2.Text = If(POS3.PositionsNr, "")
            rpt.txtPackstücke2.Text = If(POS3.Packstücke, "")
            rpt.txtWarenbezeichnung2.Text = If(POS3.Warenbezeichnung, "")
            rpt.txtWtNr1_2.Text = If(POS3.Warennummer1, "")
            rpt.txtWtNr2_2.Text = If(POS3.Warennummer2, "")
            rpt.txtWtNr3_2.Text = If(POS3.Warennummer3, "")
            rpt.txtWtNr4_2.Text = If(POS3.Warennummer4, "")
            rpt.txtWtNr5_2.Text = If(POS3.Warennummer5, "")
            rpt.txtUrsprungsland2.Text = If(POS3.UrsprungslandCode, "")

            If POS3.Verfahren IsNot Nothing Then
                While POS3.Verfahren.length < 7
                    POS3.Verfahren = POS3.Verfahren & "0"
                End While
                rpt.txtVerfahren1_2.Text = POS3.Verfahren.ToString.Substring(0, 4)
                rpt.txtVerfahren2_2.Text = POS3.Verfahren.ToString.Substring(4, 3)
            Else
                rpt.txtVerfahren1_2.Text = ""
                rpt.txtVerfahren2_2.Text = ""
            End If
            rpt.txtEigenmasse2.Text = If(POS3.Eigenmasse, "")
            rpt.txtRohmasse2.Text = If(POS3.Rohmasse, "")
            rpt.txtSummarischeAnmeldung2.Text = If(POS3.SumAnmeldungVorpapier, "")
            rpt.txtPraeferenz2.Text = If(POS3.Präferenz, "")
            rpt.txtKontingent2.Text = If(POS3.Kontingent, "")
            rpt.txtBesondereMasseinheit2.Text = If(POS3.BesondereMasseinheit, "")
            rpt.txtBesondereVermerke2.Text = If(POS3.BesondereVermerke, "")

        End If

        '    print.Viewer.LoadDocument(rpt)
        '   print.Show()
        Try
            rpt.Run(False)
            rpt.Document.Printer.PrinterName = cboPrinter._value
            rpt.Document.Print(CBool(cboPrinter.Text = ""), False)
            rpt.Dispose()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub

    Private Sub UsrCntlEinheitspapier1_Changed() Handles UsrCntlEinheitspapier1.ADD, UsrCntlEinheitspapier1.DEC, UsrCntlEinheitspapier1.KGchanged
        Dim Eigenmasse As Double = 0
        For Each c In UsrCntlEinheitspapier1.FlowLayoutPanel.Controls
            Dim usr As usrcntlEinheitspapierPos0735 = DirectCast(c, usrcntlEinheitspapierPos0735)
            If IsNumeric(usr.txtEigenmasse.Text) Then Eigenmasse += CDbl(usr.txtEigenmasse.Text)
        Next
        lblEigenmasse.Text = Eigenmasse.ToString("F") & " kg"
    End Sub

   

   
    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles btnNeu.Click
        resetForm(True)
    End Sub

    Sub resetForm(resetTxt)
        EPBES = New cEP0735_Versand '(cboSearch._value)
        UsrCntlEinheitspapier1.removeAllPos()
        UsrCntlEinheitspapier1.addPos()
        fillData()
    End Sub
    Private Sub timerSave_Tick(sender As Object, e As EventArgs) Handles timerSave.Tick
        timerSave.Enabled = False
    End Sub

    


End Class